clc
close all
clear all


%% Initialisation
no_fichier_a_visualiser = 110; % total=468;


%% Lecture du fichier index.txt
fid = fopen('index.txt');
data = textscan(fid, '%s %s %s');
fclose(fid);


%% Lecture fichiers
carte_saillence_auto = double(imread(data{1}{no_fichier_a_visualiser}));
carte_oeil_fix = double(imread(data{2}{no_fichier_a_visualiser}));
img_original_tmp = double(imread(data{3}{no_fichier_a_visualiser}));
img_original = imresize(img_original_tmp, size(carte_saillence_auto), 'bilinear'); %resize car img 2fois plus petite


%% Alphablending Saillence
rgb_saillence_auto = ind2rgb(carte_saillence_auto, jet(256))*256;
alpha_coeff = 0.5;

img_alpha_saillence = ( 1-alpha_coeff ) .* img_original + alpha_coeff .* rgb_saillence_auto;


%% Indices fixations
[Y_fix, X_fix] = find(carte_oeil_fix > 0);


%% Visualisation
figure(1)
imshow(uint8(img_alpha_saillence))
title( ['Alphablending saillence automatique et img originale - img no ' num2str(no_fichier_a_visualiser)] )

figure(2)
imshow(uint8(img_original))
hold on 
plot(X_fix, Y_fix, 'rx')
hold off
title( ['Points de fixations humains sur img originale - img no ' num2str(no_fichier_a_visualiser)] )